﻿<?php
class CommonAction extends Action
{
    public function _initialize()
    {
		// 用户权限检查
		if (C ( 'USER_AUTH_ON' ) && !in_array(MODULE_NAME,explode(',',C('NOT_AUTH_MODULE')))){
			import ( '@.ORG.RBAC' );
			if ($_SESSION['rid'] !=1 && ! RBAC::AccessDecision ()) {
				//检查认证识别号
				if (! $_SESSION [C ( 'USER_AUTH_KEY' )]) {
					//跳转到认证网关
					redirect ( PHP_FILE . C ( 'USER_AUTH_GATEWAY' ) );
				}
				// 没有权限 抛出错误
				if (C ( 'RBAC_ERROR_PAGE' )) {
					// 定义权限错误页面
					redirect ( C ( 'RBAC_ERROR_PAGE' ) );
				} else {
					if (C ( 'GUEST_AUTH_ON' )) {
						$this->assign ( 'jumpUrl', PHP_FILE . C ( 'USER_AUTH_GATEWAY' ) );
					}
                    // 提示错误信息
                    if(preg_match('/(insert|edit|delete|update|set|ajax)/', ACTION_NAME))
                        exit("<script type='text/javascript'>parent.complete('".urlencode(L ( '_VALID_ACCESS_' ))."',0)</script>");
                    else
					   $this->error ( L ( '_VALID_ACCESS_' ));
				}
			}
		}
    }

    //记录系统日志
    protected function _writelog($action,$result)
    {
		$log = M('Logs');
		$data['uid'] = $_SESSION[C('USER_AUTH_KEY')];
		$data['action'] = $action;
		$data['result'] = $result ? 1 : 0;
		$log->add($data);
    }
    //没有就新增一条
    protected function addPatientAut($Patient_authority,$zhuyuanhao)
    {
    	import ( '@.ORG.Oracle' );
    	$db = new Oracle();
		$conn = $db->logon();
		$sql = "SELECT ZHUYUANHAO,TELPHONE,IN_TIME,BINGQUCODE,KESHICODE,SHENFENZHENG,PAT_NAME,YNOUT,TO_CHAR(OUTDATE,'YYYY-MM-DD') OUTDATE,TO_CHAR(SHOUSHURQ,'YYYY-MM-DD') SHOUSHURQ,(CASE YN_SHOUSHU WHEN '是' THEN 1 ELSE 0 END) YN_SHOUSHU,(CASE YN_ICU WHEN '是' THEN 1 ELSE 0 END) YN_ICU FROM view_rwzb_patientinfo where ZHUYUANHAO='$zhuyuanhao' AND ROWNUM <2";
		$patientinfo = $db->query($sql,$conn);
		$patientinfo = $patientinfo[0];
		$pa_data = array(
			'zhuyuanhao' => $zhuyuanhao,
			'kid' => $patientinfo['KESHICODE'],
			'bid' => $patientinfo['BINGQUCODE'],
			'is_out' => $patientinfo['YNOUT'],
			'out_date' => $patientinfo['OUTDATE'] ? substr($patientinfo['OUTDATE'],0,10) : null,
			'is_icu' => $patientinfo['YN_ICU'],
			'is_operation_z' => $patientinfo['YN_SHOUSHU'],
			'operation_z_date' => $patientinfo['SHOUSHURQ'] ? substr($patientinfo['SHOUSHURQ'],0,10) : null,
            'pz_status' => isset($patientinfo['VISIT_SPECIAL']['YNSTAY']) ? $patientinfo['VISIT_SPECIAL']['YNSTAY'] : 0,
            'jc_status' => 0,
		);
		$Patient_authority->add($pa_data);
    }
    //数据权限过滤
    protected function user_filter($flag = 1,$field = 'user_id')
    {
    	$map = null;
    	if($_SESSION['rid'] == 1)//超级管理员
    	{

    	}
    	else
    	{
    		if($flag == 0)
    			$map = $field.'='.$_SESSION[C('USER_AUTH_KEY')];	
    		else
    			$map[$field] = $_SESSION[C('USER_AUTH_KEY')];
    	}
    	return $map;
    }
    //数据权限过滤
    protected function bingqu_filter($flag = 1,$field = 'BINGQUCODE')
    {
    	$map = null;
    	if($_SESSION['rid'] == 1 || $_SESSION['account'] == 'ssjr')//超级管理员
    	{

    	}
    	else
    	{
    		if($flag == 0)
    			$map = ' AND '.$field.'='.$_SESSION['bingqu'];	
    		else
    			$map[$field] = $_SESSION['bingqu'];
    	}
    	return $map;	
    }
        //数据权限过滤
    protected function zhuyuan_filter($flag = 1,$field = 'zhuyuanhao')
    {
    	$map = null;
    	if($_SESSION['rid'] == 1 || $_SESSION['account'] == 'ssjr')//超级管理员
    	{

    	}
    	else
    	{
            if(!isset($_SESSION['zhuyuanhao']))
            {
                import ( '@.ORG.Oracle' );
                $db = new Oracle();
                $conn = $db->logon();
                $sql = "SELECT ZHUYUANHAO FROM view_rwzb_patientinfo WHERE BINGQUCODE=".$_SESSION['bingqu'];
                $list = $db->query($sql,$conn);
                $_SESSION['zhuyuanhao'] = array();
                foreach ($list as $key => $value) {
                    $_SESSION['zhuyuanhao'][] = $value['ZHUYUANHAO'];
                    unset($list[$key]);
                }
            }
    		if($flag == 0)
    			$map = ' AND '.$field.' IN('.implode(',',$_SESSION['zhuyuanhao']).')';	
    		else
    			$map[$field] = array('in',$_SESSION['zhuyuanhao']);
    	}
    	return $map;	
    }

}
?>

