<?php
class IndexAction extends CommonAction
{
    /**
    +----------------------------------------------------------
    * 默认操作
    +----------------------------------------------------------
    */
    public function index()
    {
        $role_auth = F('ROLE_AUTH'.$_SESSION['rid']);
        if(empty($role_auth))
        {
    		$access = M('Gate_access');
    		if($_SESSION['rid'] == 1)
    		{
    		    $where = 'a.level = 1';
    		    $mlist = $access->query('SELECT name,title,id FROM  gate_node a where '.$where .' order by sort');
    		    $l2 = $access->query('SELECT name,title,id,pid FROM gate_node where id<>44 and level=2 order by id');
                $l3 = $access->query('SELECT name,title,id,pid FROM gate_node where level = 3 and menu = 0 order by id');
    		}
    		else
    		{
    		    $where = 'a.level = 1 and role_id ='.$_SESSION['rid'];
    		    $mlist = $access->query('SELECT b.name,b.title,b.id FROM gate_access a LEFT JOIN gate_node b on b.id=a.node_id where '.$where .' order by sort');
    		    $l2 = $access->query('SELECT b.name,b.title,b.id,b.pid FROM gate_access a LEFT JOIN gate_node b on b.id=a.node_id where id<>43 and a.level = 2 and role_id ='.$_SESSION['rid'].' order by id');
    		    $l3 = $access->query('SELECT b.name,b.title,b.id,b.pid FROM gate_access a LEFT JOIN gate_node b on b.id=a.node_id where a.level = 3 and b.menu = 0  and role_id = '.$_SESSION['rid'].' order by b.id');
    		};
            $role_auth['mlist'] = $mlist;

            if(strstr($l3[0]['name'],'/'))
                $url = $l3[0]['name'];
            else
                $url = $l2[0]['name'].'/'.$l3[0]['name'];
            $role_auth['url'] = $url;

            $html = '';
            foreach($l2 as $k2=>$v2)
            {
                $html .= '<h3 class="f14" id="h'.$v2['pid'].'" style="display:none"><span title="展开与收缩" class="switchs cu on"></span>'.$v2['title'].'</h3><ul style="display:none" id="ul'.$v2['pid'].'">';
                foreach($l3 as $k3=>$v3)
                {
                    if($v3['pid'] == $v2['id'])
                    {
                        if(strstr($v3['name'],'/'))
                            $url23 = $v3['name'];
                        else
                            $url23 = $v2['name'].'/'.$v3['name'];

                        $html .= "<li class=\"sub_menu\" data-url=\"{$url23}\" id=\"_MP100".$k2."_".$k3."\"><a style=\"outline: medium none;\" hidefocus=\"true\" href=\"javascript:;\" onclick=\"_MP(\'100".$k2."_".$k3."\',\'__APP__/{$url23}\',\'{$v3['title']}\');\">{$v3['title']}</a></li>";
                    }
                }
                $html .= '</ul>';
            }
            $role_auth['html'] = $html;
            F('ROLE_AUTH'.$_SESSION['rid'],$role_auth);
        }
        else
        {
            $url = $role_auth['url'];
            $html = $role_auth['html'];
            $mlist = $role_auth['mlist'];
        }
		$this->assign('url',$url);
        $this->assign('html',$html);
		$this->assign('mlist',$mlist);
		$this->display();
    }

    /**
     * 菜单供异步调用
     */
    public function menu()
    {
		$node = M('node');
		if(empty($_GET['pid']))
		{
		    $this->error('没有指定父级菜单');
		}
		else
		{
		    $list = $node->query('select name,title,level,pid,id from gate_node where pid='.$_GET['pid'].' or (pid in(select id from gate_node where menu = 0 and pid='.$_GET['pid'].') and menu = 0');
		}
		$level2 = $level3 = array();
		foreach($list as $v)
		{
		    switch($v['level'])
		    {
			case 2:
			    $level2[] = array($v['name'],$v['title'],$v['id']);
			break;
			case 3:
			    $level3[$v['pid']][] = array($v['name'],$v['title'],$v['pid']);
			break;
		    }
		}
		unset($list);
		$html = '';
		foreach($level2 as $k2=>$v2)
		{
		    $html .= '<h3 class="f14"><span title="展开与收缩" class="switchs cu on"></span>'.$v2[1].'</h3><ul>';
		    foreach($level3[$v2[2]] as $k3=>$v3)
		    {
			$html .= "<li class='sub_menu' data-url='{$v2[0]}/{$v3[0]}' id='_MP100".$k2."_".$k3."'><a style='outline: medium none;' hidefocus='true' href=\"javascript:_MP('100".$k2."_".$k3."','__APP__/{$v2[0]}/{$v3[0]}','{$v3[1]}');\">{$v3[1]}</a></li>";
		    }
		    $html .= '</ul>';
		}
		unset($level2);
		unset($level3);
		$this->assign('html',$html);
		$this->display();
    }
  /**
    +----------------------------------------------------------
    *闸机设备
    +----------------------------------------------------------
    */
    public function dev()
    {
        $Dev = M("Dev");
        $list = $Dev->findAll();

        $one_open = M('Config')->where("`key` = 'ONE_OPEN'")->getField('value');

        $this->assign('list',$list);
        $this->assign('one_open',$one_open);
        $this->display();
    }
   /**
    +----------------------------------------------------------
    *服务器环境信息
    +----------------------------------------------------------
    */
    public function info()
    {
    	$able=get_loaded_extensions();
    	$moudle = '';
    	foreach ($able as $key=>$value)
    	{
    		if ($key!=0 && $key%15==0) 
    		{
    			$moudle .= '<br />';
    		}
    		$moudle .= $value.' ';
    	}
    	$os = explode(" ", php_uname());
		$info = array(
		'操作系统'=>$os[0].'内核版本:'.('/'== DIRECTORY_SEPARATOR ? $os[2] : $os[1]),
		'运行环境'=>$_SERVER["SERVER_SOFTWARE"],
		'PHP运行方式'=>php_sapi_name(),
		'PHP版本'=>PHP_VERSION,
		'PHP已编译的模块'=>$moudle,
		'MYSQL版本' => mysql_get_server_info(),
		'上传附件限制'=>ini_get('upload_max_filesize'),
		'POST提交最大限制'=>ini_get('post_max_size'),
		'memory_limit'=>ini_get('upload_max_filesize'),
		'Socket超时'=>ini_get('default_socket_timeout'),
		'Execution超时'=>ini_get('max_execution_time'),
		'服务器主机名'=>('/'== DIRECTORY_SEPARATOR ? $os[1] : $os[2]),
		'服务器域名/IP'=>$_SERVER['SERVER_NAME'].' [ '.gethostbyname($_SERVER['SERVER_NAME']).' ]',
		'服务器端口'=>$_SERVER['SERVER_PORT'],
		'服务器时间'=>date('Y-m-d H:i:s'),
		'剩余空间'=>round((@disk_free_space(".")/(1024*1024*1024)),2).'G',
		'网站根目录'=>$_SERVER['DOCUMENT_ROOT']?str_replace('\\','/',$_SERVER['DOCUMENT_ROOT']):str_replace('\\','/',dirname(__FILE__)),
		);

        $this->assign('info',$info);
        $this->display();
    }
   /**
    +----------------------------------------------------------
    *获取服务器时间
    +----------------------------------------------------------
    */
    public function getTime()
    {
    	echo json_encode(array('time'=>date('Y-m-d H:i:s')));
    }
   /**
    +----------------------------------------------------------
    *更新设备状态
    +----------------------------------------------------------
    */
    public function updatedev()
    {
        $Dev = M("Dev");
        $list = $Dev->field('code,active_time')->findAll();
        $arr = array();
        foreach($list as $l)
        {
            if(time() - $l['active_time'] > C('DEVICE_ACTIVE_TIME'))
                $arr[$l['code']] = 'disabled.gif';
            else
                $arr[$l['code']] = 'enable.gif';
        }
        echo json_encode($arr);
    }
    /**
    +----------------------------------------------------------
    *设置一键开门
    +----------------------------------------------------------
    */
    public function setoneopen()
    {
        $one_open = M('Config')->where("`key` = 'ONE_OPEN'")->getField('value');
        if($one_open != intval($_GET['v']))
            $res = M('Config')->where("`key` = 'ONE_OPEN'")->setField('value',$_GET['v']);
        else
            $res = 1;
        echo $res;
    }
   /**
    +----------------------------------------------------------
    * 系统地图
    +----------------------------------------------------------
    */
    public function map()
    {
        $node = M('node');
        $where = 'menu = 0';
        if(empty($_GET['id']))
        {
            $list = $node->where($where)->findAll();
        }
        else
        {
            $list = $node->query('SELECT * FROM gate_node a LEFT JOIN (select node_id from gate_access where role_id='.$_GET['id'].') b on a.id=b.node_id where '.$where);
        }
        $level1 = $level2 = $level3 = array();
        foreach($list as $v)
        {
            switch($v['level'])
            {
                case 1:
                    $level1[$v['pid']][] = array($v['name'],$v['title'],$v['id'],$v['pid'],$v['node_id']);
                    break;
                case 2:
                    $level2[$v['pid']][] = array($v['name'],$v['title'],$v['id'],$v['pid'],$v['node_id']);
                    break;
                case 3:
                    $level3[$v['pid']][] = array($v['name'],$v['title'],$v['id'],$v['pid'],$v['node_id']);
                    break;
            }
        }
        $html = '';
        foreach($level1[0] as $vk=>$v1)
        {
            if($vk == 0 || $vk == 2 || $vk == 3)
                $html .= '<div class="map-menu lf">';
            $html .= '<ul><li class="title">'.$v1[1].'</li>';
            foreach($level2[$v1[2]] as $v2)
            {
                $html .= '<li class="title2">'.$v2[1].'</li>';
                foreach($level3[$v2[2]] as $v3)
                {
                    $html .= '<li>'.$v3[1].'</li>';
                }
            }
            $html .= '</ul>';
            if($vk == 1 || $vk == 2 || $vk == 5)
                $html .= '</div>';
        }
        $this->assign('html',$html);
        $this->display();
    }
}
?>
