<?php
class sysAction extends CommonAction
{
    public function bquser()
    {
        import ( '@.ORG.Oracle' );
        $db = new Oracle();
        $conn = $db->logon();
        $sql = "SELECT BINGQUCODE,BINGQU FROM view_rwzb_unit WHERE BINGQU NOT LIKE '%旧%'";
        $list = $db->query($sql,$conn);
        $data = array();
        $inserSql = '';
        $csv = "用户名,密码,病区\r\n";
        foreach ($list as $key => $value) {
            $data['id'] = $key+2;
            $data['status'] = 1;
            $data['account'] = 'bquser'.$value['BINGQUCODE'];
            $password = rand_string(6);
            $data['password'] = pwdHash($password);
            $data['status'] = 1;
            $data['role_id'] = 2;

            $inserSql .= "insert into gate_user(id,account,password,status)values('{$data['id']}','{$data['account']}','{$data['password']}','{$data['status']}');\r\n";
            $inserSql .= "insert into gate_role_user(role_id,user_id)values('2','{$data['id']}');\r\n";
            $csv .= "{$data['account']},$password,{$value['BINGQU']}<br>";
        }
        echo $csv;
        //file_put_contents('bquser.sql', $inserSql);
        //file_put_contents('bquser.csv', $csv);

    }
    /**
    +----------------------------------------------------------
    * 系统日志
    +----------------------------------------------------------
    */
    public function log()
    {
        $Log = M('Logs');
        import("ORG.Page");
        $map = array();
        if(empty($_GET['btime'])) $_GET['btime'] = date('Y-m-d 00:00:00');
        if(empty($_GET['etime'])) $_GET['etime'] = date('Y-m-d H:i:s');
        if($_GET['account']) $map['account'] = array('like', "%{$_GET['account']}%");
        if($_GET['action']) $map['action'] = array(array('neq',''),array('like', "%{$_GET['action']}%"));
        $map = array();
        $map['time'] = array('between', "'{$_GET['btime']}','{$_GET['etime']}'");
        $count = $Log->where($map)->count();
        $p = new Page($count,C('DATA_PAGE'));
        $list = $Log->order('id desc')->where($map)->limit($p->firstRow.','.$p->listRows)->join('gate_user on gate_user.id = gate_logs.uid')->field('gate_logs.*,gate_user.account')->findAll();
        $p->setConfig('prev',"上一页");
        $p->setConfig('next',"下一页");
        $p->setConfig('first',"首页");
        $p->setConfig('last',"尾页");
        $page = $p->show();

        $this->assign('page',$page);
        $this->assign('list',$list);
        $this->assign('filter', $_GET);
        $this->display();
    }
   /**
    +----------------------------------------------------------
    * 修改密码
    +----------------------------------------------------------
    */
    public function updatepasswd()
    {
        $user = M("User");
        if (strlen($_POST['old_password']) < 1)
        {
            echo "<script type='text/javascript'>parent.complete('".urlencode('旧密码必须')."',0)</script>";
            return;
        }
        if (md5(trim($_POST['old_password'])) != $_SESSION['password'])
        {
            echo "<script type='text/javascript'>parent.complete('".urlencode('旧密码输入错误')."',0)</script>";
            return;
        }
        if (strlen($_POST['new_password']) < 1)
        {
            echo "<script type='text/javascript'>parent.complete('".urlencode('新密码必须')."',0)</script>";
            return;
        }
        if (strlen($_POST['new_pwdconfirm']) < 1)
        {
            echo "<script type='text/javascript'>parent.complete('".urlencode('重复新密码必须')."',0)</script>";
            return;
        }
        if ($_POST['new_password'] != $_POST['new_pwdconfirm'])
        {
            echo "<script type='text/javascript'>parent.complete('".urlencode('俩次输入密码不一致')."',0)</script>";
            return;
        }
        $data['password'] = pwdHash($_POST['new_password']);
        $res = $user->where('id='.$_SESSION[C('USER_AUTH_KEY')])->data($data)->save();
        $this->_writelog('用户:'.$_SESSION['account'].'修改密码',$res);
        if($res !== false)
        {
            $_SESSION['password'] = $data['password'];
            echo "<script type='text/javascript'>parent.complete('".urlencode('修改密码成功！')."',1)</script>";
        }
        else
        {
           echo "<script type='text/javascript'>parent.complete('".urlencode('修改密码失败！')."',0)</script>";
        }
    }


    /**
     * @desc 用户列表
     * @fina 2012-04-13
     */
    public function user()
    {
        $User = M("User");
        import("ORG.Page");
        $map = array();
        if($_GET['account']) $map['account'] = array('like', "%{$_GET['account']}%");
        if($_GET['rid']) $map['role_id'] = array('eq', $_GET['rid']);
            $count = $User->where($map)->count();
        $p = new Page($count,C('DATA_PAGE'));
        $list = $User->where($map)->limit($p->firstRow.','.$p->listRows)->order('gate_user.id desc')->join('gate_role_user on user_id = gate_user.id')->join('gate_role on role_id = gate_role.id')->field('gate_user.id,name,role_id,account,last_login_time,last_login_ip,login_count,gate_user.status,create_time')->findAll();
        $p->setConfig('prev',"上一页");
        $p->setConfig('next',"下一页");
        $p->setConfig('first',"首页");
        $p->setConfig('last',"尾页");
        $page = $p->show();
        $this->assign('page',$page);
        $this->assign('list',$list);
        $this->assign('filter', $_GET);
        $this->display();
    }
    /**
     * @desc 递归获取子角色
     * @fina 2012-04-13
     */
   public static function getSonRole($rid,$id)
   {
        if(!$rid) return;
        $Role = M("Role");
        $arr = array(
        '5' => '根',
        '4' => '四',
        '3' => '三',
        '2' => '二',
        '1' => '一',
        );
        $map['parent_id'] = $rid;
        
        //查出其同级用户
        $user = $Role->query('select id,account from gate_user a,gate_role_user b where a.id=b.user_id and user_id <> 1 and user_id <> '.$id.' and role_id='.$rid);
        foreach($user as $u)
        {
            echo '<li><span class="file">'.$u['account'].'<input type="checkbox" name="user[]" value="'.$u['id'].'"/></span></li>';
        }
        
        //查出其直接下级角色
        $query = $Role->where($map)->field('id,name,class_id')->order('class_id desc')->findAll();
        foreach($query as $q)
        {   
            $id = $Role->query('select count(*) as cnt from gate_role_user where role_id='.$q['id']);
            $rid = $Role->query('select count(*) as cnt from gate_role where parent_id='.$q['id']);
            if($id[0]['cnt'] > 0 || $rid[0]['cnt'] > 0)
            {
                echo '<li class="closed"><span class="folder">'.$q['name'].'【'.$arr[$q['class_id']].'级角色】</span><ul>';
                AdaccessAction::getSonRole($q['id'],0);
            }
            else
            {
               echo '<li><span class="file">'.$q['name'].'【'.$arr[$q['class_id']].'级角色】</span><ul>';
            }
            echo '</ul></li>';
        }
        
   } 
    /**
     * @desc 添加用户动作
     * @fina 2012-04-13
     */
    public function insertuser()
    {
        $User = D("User");
        if($vo = $User->create()) {
            $list=$User->add();
            $this->_writelog('添加用户:'.$_POST['account'],$list);
            if($list!==false){
                $Ru = M("Role_user");
                $Ru->data(array('role_id'=>$_POST['role_id'],'user_id'=>$list))->add();
                echo "<script type='text/javascript'>parent.complete('".urlencode('添加用户成功,正在跳转...')."',1)</script>";
            }else{
                echo "<script type='text/javascript'>parent.complete('".urlencode('添加用户失败！')."',0)</script>";
            }
        }else{
                echo "<script type='text/javascript'>parent.complete('".urlencode($User->getError())."',0)</script>";
        }
    }

    /**
     * @desc 更新用户动作
     * @fina 2012-04-13
     */
    public function updateuser()
    {
        //数据库操作
        $User = D("User");
        if($vo = $User->create()) 
        {
            $list=$User->save();
            if($list!==false){
                $Ru = M("Role_user");
                $Ru->where('user_id='.$_POST['id'])->save(array('role_id'=>$_POST['role_id']));
                $this->_writelog('修改用户:'.$_POST['account'],1);
                echo "<script type='text/javascript'>parent.complete('".urlencode('更新用户信息成功,正在跳转...！')."',1)</script>";
            }
            else
            {
                $this->_writelog('修改用户:'.$_POST['account'],0);
                echo "<script type='text/javascript'>parent.complete('".urlencode('更新用户信息失败！')."',0)</script>";
            }
        }
        else
        {
            echo "<script type='text/javascript'>parent.complete('".urlencode($User->getError())."',0)</script>";
        }
    }

    /**
     * @desc 删除用户动作
     * @fina 2012-04-13
     */
    public function deleteuser()
    {
        if(!empty($_GET['id']))
            {
            $User = M("User");
            $result = $User->where('id='.$_GET['id'])->delete();
            $this->_writelog('删除用户ID:'.$_GET['id'],$result);
            if(false !== $result) {
                $this->success('删除用户成功！');
            }else{
                $this->error('删除用户出错！');
            }
        }
        else
        {
            $User = M("User");
            if($_POST['deletesel'] == 'selected')
            {
                $ids = implode( ',', $_POST['user_id']);
                $res = $User->where('id in('.$ids.')')->delete(); 
            }
            else 
            {
                $ids = '全部';
                $where = 'id<>1';
                if($_POST['account']) $where .= " and account like '{$_POST['account']}%'";
                if($_POST['rid']) $where .=' and role_id = '.$_POST['rid']; 
                $res = $User->query('delete gate_user,gate_role_user from gate_user left join gate_role_user on gate_user.id=gate_role_user.user_id where '.$where);
                
            }
            $this->_writelog('删用户ID:'.$ids,$res);
            if(false !== $res) {
                $this->success('删除用户成功！');
            }else{
                $this->error('删除用户出错！');
            }
        }
    }

    /**
     * @desc 编辑用户
     * @fina 2012-04-13
     */
    public function adduser()
    {
        if(!empty($_GET['id'])) {
            $User = M("User");
            $vo = $User->query('select a.*,b.role_id from gate_user a,gate_role_user b where a.id='.$_GET['id'].' and a.id=b.user_id');
            if($vo) {
                $this->assign('vo',$vo[0]);
            }else{
                $this->error("编辑项不存在！");
            }
        }
        $role = M('Role');
        $role = $role->field('id,name')->select();
        $this->assign('role', $role);
        $this->assign('rid', $_GET['rid']);
        $this->display('adduser');
    }

    
    /**
     * @desc 禁用|启用用户动作
     * @fina 2012-04-13
     */
    public function activeuser() 
    {
        //数据库操作
        $User = M("User");
        if(!$_GET['id'])
        {
            $this->error('此项不存在');
            exit;
        }
        $data['status'] = $_GET['status'];
        $vo = $User->where('id='.$_GET['id'])->save($data);
        $this->_writelog(($_GET['status'] == 1 ? '启用' : '禁用').'用户ID:'.$_GET['id'],$vo);
        if($vo)
        {
            $this->success(($_GET['status'] == 1 ? '启用' : '禁用').'用户成功！');
        }else{
            $this->error(($_GET['status'] == 1 ? '启用' : '禁用').'用户失败！');
        }
    }

    /**
     * @desc 角色列表
     * @fina 2012-04-13
     */
    public function role()
    {
        $role = M("role");
        import("ORG.Page");
        $map = array();
        
        if($_GET['name']) $map['name'] = array('like', "%{$_GET['name']}%");
            $count = $role->where($map)->count();
        $p = new Page($count,C('DATA_PAGE'));
        $list = $role->where($map)->limit($p->firstRow.','.$p->listRows)->order('id desc')->findAll();
        $p->setConfig('prev',"上一页");
        $p->setConfig('next',"下一页");
        $p->setConfig('first',"首页");
        $p->setConfig('last',"尾页");
        $page = $p->show();
    
        $this->assign('page',$page);
        $this->assign('list',$list);
        $this->assign('filter', $_GET);
        $this->display();
    }

    /**
     * @desc 添加角色动作
     * @fina 2012-04-13
     */
    public function insertrole()
    {
        $role = D("role");
        if($vo = $role->create()) {
            $list=$role->add();
            $this->_writelog('添加角色:'.$_POST['name'],$list);
            if($list!==false){
                echo "<script type='text/javascript'>parent.complete('".urlencode('添加角色成功,正在跳转...')."',1)</script>";
            }
            else
            {
                echo "<script type='text/javascript'>parent.complete('".urlencode('添加角色失败！')."',0)</script>";
            }
        }
        else
        {
                echo "<script type='text/javascript'>parent.complete('".urlencode($role->getError())."',0)</script>";
        }
    }

    /**
     * @desc 更新角色动作
     * @fina 2012-04-13
     */
    public function updaterole() 
    {
        //数据库操作
        $role = D("role");
        if($vo = $role->create()) 
        {
            $list=$role->save();
            $this->_writelog('修改角色:'.$_POST['name'],$list);
            if($list!==false){
                echo "<script type='text/javascript'>parent.complete('".urlencode('更新角色信息成功,正在跳转...！')."',1)</script>";
            }else{
                echo "<script type='text/javascript'>parent.complete('".urlencode('更新角色信息失败！')."',0)</script>";
            }
        }else{
            echo "<script type='text/javascript'>parent.complete('".urlencode($role->getError())."',0)</script>";
        }
    }   

    /**
     * @desc 删除角色动作
     * @fina 2012-04-13
     */
    public function deleterole()
    {
        if(!empty($_GET['id']))
            {
            $role = M("role");
            $result = $role->where('id='.$_GET['id'])->delete();
            $this->_writelog('删除角色ID:'.$_GET['id'],$result);
            $result = $role->query('delete gate_user,gate_role_user,gate_access from gate_user left join gate_role_user on gate_user.id=gate_role_user.user_id left join gate_access on gate_role_user.role_id=gate_access.role_id where gate_role_user.role_id = '.$_GET['id']);
            if(false !== $result) {
                F('ROLE_AUTH'.$_GET['id'],NULL);
                $this->success('删除角色成功！');
            }else{
                $this->error('删除角色出错！');
            }
        }else{
            $role = M("role");
            if($_POST['deletesel'] == 'selected')
            {
                $ids = implode( ',', $_POST['role_id']);
                $res = $role->where('id in('.$ids.')')->delete(); 
                $result = $role->query('delete gate_user,gate_role_user,gate_access from gate_user left join gate_role_user on gate_user.id=gate_role_user.user_id left join gate_access on gate_role_user.role_id=gate_access.role_id where role_id = '.'id in('.$ids.')');
                $role_ids = $_POST['role_id'];
            }
            else
            {
                $ids = '全部';
                $where = '';
                if($_POST['name']) $where = " and gate_role.name like '{$_POST['name']}%'";
                $res = true;
                $result = $role->query('delete gate_role,gate_user,gate_role_user,gate_access from gate_role left join gate_role_user on gate_role.id=gate_role_user.role_id left join gate_user on gate_user.id=gate_role_user.user_id left join gate_access on gate_role_user.role_id=gate_access.role_id where gate_role.id<>1'.$where);
                $role_ids = $role->where('gate_role.id<>1'.$where)->field('id')->findAll();
            }
            $this->_writelog('删除角色ID:'.$ids,$res);
            if(false !== $res && false !== $result) 
            {
                if($role_ids)
                {
                    foreach ($role_ids as $rid) {
                        if(is_array($rid))
                            F('ROLE_AUTH'.$rid['id'],NULL);
                        else
                            F('ROLE_AUTH'.$rid,NULL);
                    }
                }
                $this->success('删除角色成功！');
            }else{
                $this->error('删除角色出错！');
            }
        }
    }

    /**
     * @desc 编辑角色
     * @fina 2012-04-13
     */
    public function addrole()
    {
        if($_POST['act'] == 'classajax' && $_POST['class_id'])
        {
                $Model = new Model();
            $lista = $Model->query("select name,id from gate_role where class_id=".($_POST['class_id']+1));
            if(count($lista)>0)
            {
                    foreach($lista as $a)
                    {
                        $select .='<option value="'.$a['id'].'"'.($a['id'] == $_POST['parent_id'] ? ' selected' : '').'>'.$a['name'].'</option>';
                    }
            }
            else 
                $select = '<option value="0">还没有'.($_POST['class_id']+1).'级的角色</option>';
                echo $select;
                exit;
        }   

    $role = M("role");
    $classId = $role->field('class_id')->where('id='.$_SESSION['rid'])->find();
    $classId = $classId['class_id'];

    if($classId == 1)
    {
        $this->error('一级别角色下的用户没有权限添加角色');
    }
    $arr = array(
    '4' => '四',
    '3' => '三',
    '2' => '二',
    '1' => '一',
    );
    $class = array();
    foreach($arr as $k=>$a)
    {
        if($k<$classId)
        {
        $class[$k] = $a;
        }
    }
    $this->assign('class',$class);
        if(!empty($_GET['id'])) 
        {    
            $vo = $role->getById($_GET['id']);
            if($vo) {
                $this->assign('vo',$vo);
                $this->display('addrole');
            }else{
                $this->error("编辑项不存在！");
            }
        }
        else
        {
            $this->display();
        }
    }

    /**
     * @desc 授权显示
     * @fina 2012-04-13
     */
    public function node()
    {
        if(empty($_GET['id'])) $this->error('没有指定角色！');
        $node = M('node');
        if(empty($_GET['id']))
        {
            $list = $node->where($where)->findAll();
        }
        else
        {
            $list = $node->query('SELECT * FROM gate_node a LEFT JOIN (select node_id from gate_access where role_id='.$_GET['id'].') b on a.id=b.node_id order by a.sort');
        }
        $level1 = $level2 = $level3 = $level4 = array();
        foreach($list as $v)
        {
            switch($v['level'])
            {
            case 1:
                $level1[$v['pid']][] = array($v['name'],$v['title'],$v['id'],$v['pid'],$v['node_id']);
            break;
            case 2:
                $level2[$v['pid']][] = array($v['name'],$v['title'],$v['id'],$v['pid'],$v['node_id']);
            break;
            case 3:
                $level3[$v['pid']][] = array($v['name'],$v['title'],$v['id'],$v['pid'],$v['node_id'],$v['menu']);
            break;
            }
        }
        $html = '';
        foreach($level1[0] as $v1)
        {
            $html .= '<li class="closed"><span class="folder">'.$v1[1].'<input type="checkbox" name="node[]" '.($v1[4] ? 'checked ' : '').'value="'.$v1[0].'_'.$v1[2].'_'.$v1[3].'_1" id="'.$v1[2].'" onclick="fnrs(this.id,1)"></span><ul>';
            foreach($level2[$v1[2]] as $v2)
            {
            $html .= '<li class="closed"><span class="folder">'.$v2[1].'<input type="checkbox" name="node[]" '.($v2[4] ? 'checked ' : '').'value="'.$v2[0].'_'.$v2[2].'_'.$v2[3].'_2" id="'.$v2[2].'" class="'.$v2[3].'" onclick="fnrs(this.id,2)"></span><ul>';
            $temp = $tempp = array();
            foreach($level3[$v2[2]] as $v3)
            {
                if($v3[5] == 0) 
                $temp[] = $v3;
                else
                $tempp[$v3[5]][] = $v3;
            }
            $cnt = count($temp);
            for($i=0;$i<$cnt;$i++)
            {
               $html.='<li><span class="file">'.$temp[$i][1].'<input type="checkbox" name="node[]" '.($temp[$i][4] ? 'checked ' : '').'value="'.$temp[$i][0].'_'.$temp[$i][2].'_'.$temp[$i][3].'_3" id="'.$temp[$i][2].'" class="'.$temp[$i][3].'" onclick="fnrs(this.id,3)">';
               if(isset($tempp[$temp[$i][2]])){
                   $html .= '----';
                   foreach($tempp[$temp[$i][2]] as $t2)
                   {
                    $html .= $t2[1].'<input type="checkbox" name="node[]" '.($t2[4] ? 'checked ' : '').'value="'.$t2[0].'_'.$t2[2].'_'.$t2[3].'_4" id="'.$t2[2].'" class="'.$t2[5].'" onclick="fnrs(this.id,4)">&nbsp;';
                   }
               }
               $html .= '</span></li>';
            }
            unset($temp);
            unset($tempp);
            $html .= '</ul></li>';
            }
            $html .= '</ul></li>';
        }
        $this->assign('id',$_GET['id']);
        $this->assign('html',$html);
        $this->display();
    }

    /**
     * @desc 修改角色权限
     * @fina 2012-04-13
     */
    public function grantnode()
    {
        $access = M("Access");
        $access->where('role_id='.$_POST['rid'])->delete();
        if(is_null($_POST['node']))
        {
            echo "<script type='text/javascript'>parent.complete('没有选中任何权限',0)</script>";
            exit;
        }
        foreach($_POST['node'] as $k=>$v)
        {
            $arr = explode('_',$v);
            $data[$k]['node_id'] = $arr[1];
            $data[$k]['level'] = $arr[3];
            $data[$k]['pid'] = $arr[2];
            $data[$k]['role_id'] = $_POST['rid'];
        }
        //$data[] = array('node_id'=>43,'level'=>1,'pid'=>0,'role_id'=>$_POST['rid']);
        //$data[] = array('node_id'=>44,'level'=>2,'pid'=>43,'role_id'=>$_POST['rid']);
        //$data[] = array('node_id'=>45,'level'=>3,'pid'=>23,'role_id'=>$_POST['rid']);
        //$data[] = array('node_id'=>46,'level'=>3,'pid'=>23,'role_id'=>$_POST['rid']);
        $list=$access->addAll($data);
        $this->_writelog('设置角色ID:'.$_POST['rid'].'权限',$list);
        if($list!==false){
            F('ROLE_AUTH'.$_POST['rid'],NULL);
            echo "<script type='text/javascript'>parent.complete('".urlencode('设置角色权限成功,正在跳转...')."',1)</script>";
        }else{
            echo "<script type='text/javascript'>parent.complete('".urlencode('设置角色权限失败！')."',0)</script>";
        }
    }
}

