<?php
class ManageAction extends Action
{

    public function index()
    {
	    $this->redirect(__APP__.'Manage/login');
    }
    // 用户登录页面
    public function login() {
	    if(!isset($_SESSION[C('USER_AUTH_KEY')])) {
		    $this->display();
	    }else{
		    $this->redirect(__APP__.'Index/index');
	    }
    }


   /**
    +----------------------------------------------------------
    * 验证码
    +----------------------------------------------------------
    */
    public function verify()
    {
	import("ORG.Image");
	import("ORG.String");
	Image::buildImageVerify();
    }

   /**
    +----------------------------------------------------------
    * 检查登录
    +----------------------------------------------------------
    */
    public function checklogin()
    {
	if(empty($_POST['username'])) {
		$this->error('用户名必须！');
	}elseif (empty($_POST['password'])){
		$this->error('密码必须！');
	}
    /*elseif (empty($_POST['verify'])){
		$this->error('验证码必须！');
	}
	if($_SESSION['verify'] != md5($_POST['verify'])) {
		$this->error('验证码错误！');
	}*/
        //生成认证条件
        $map =  array();
	// 支持使用绑定帐号登录
	$map['account']	= $_POST['username'];
        $map["status"]	= array('gt',0);
	import ( '@.ORG.RBAC' );
        $authInfo = RBAC::authenticate($map);
        //使用用户名、密码和状态的方式进行认证
	if(false == $authInfo)
       	{
            $this->error('用户名不存在或已禁用！');
	}
	else 
	{
        if($authInfo['password'] != md5($_POST['password'])) {
        	$this->error('密码错误！');
        }
        $_SESSION[C('USER_AUTH_KEY')] = $authInfo['id'];
        $_SESSION['bingqu'] = $authInfo['bind_account'];
        $_SESSION['email'] = $authInfo['email'];
        $_SESSION['account'] = $authInfo['account'];
        $_SESSION['password'] = $authInfo['password'];
        $_SESSION['lastLoginTime'] = $authInfo['last_login_time'];
	    $_SESSION['login_count'] = $authInfo['login_count'];
	    $ru = M('Role_user');
	    $role = $ru->where('user_id='.$_SESSION[C('USER_AUTH_KEY')])->field('role_id')->find();
        $_SESSION['rid'] = $role['role_id'];

	    if($authInfo['account']=='admin')
	    {
            	$_SESSION['administrator'] = true;
            }
            //保存登录信息
	    $User = M('User');
	    $ip	= get_client_ip();
	    $time = time();
            $data = array();
	    $data['id']	= $authInfo['id'];
	    $data['last_login_time'] = $time;
	    $data['login_count'] = array('exp','login_count+1');
	    $data['last_login_ip'] = $ip;
	    $User->save($data);
	    // 缓存访问权限
        RBAC::saveAccessList();
        $this->_writelog('用户['.$_POST['username'].'登录'.']',$authInfo);
	    $this->assign('jumpUrl', __APP__.'/index/index/');
	    $this->success('登录成功,正在跳转...');
	}
    }
    
   /**
    +----------------------------------------------------------
    * 退出
    +----------------------------------------------------------
    */
    public function logout()
    {
        session_destroy();
        if(isset($_SESSION[C('USER_AUTH_KEY')])) {
	    unset($_SESSION[C('USER_AUTH_KEY')]);
            $this->assign("jumpUrl",__URL__.'/login/');
            $this->success('退出成功！');
        }else {
            $this->error('已经退出！');
        }
    }
    //记录系统日志
    private function _writelog($action,$result)
    {
		$log = M('Logs');
		$data['uid'] = $_SESSION[C('USER_AUTH_KEY')];
		$data['action'] = $action;
		$data['result'] = $result ? 1 : 0;
		$log->add($data);
    }
}
