<?php
// 用户模型
class UserModel extends Model {
    public $_validate	=         array(
	    array('account','require','用户名不能为空'),
	    array('account','/^[a-zA-z0-9]{3,}$/i','用户名格式错误'),
	    array('account','','用户名已存在',self::EXISTS_VAILIDATE,'unique',1),
	    array('role_id','require','请选择角色'),
	    );

    public $_auto		=	array(
	    array('password','pwdHash',self::MODEL_BOTH,'callback'),
	    array('create_time','time',self::MODEL_INSERT,'function'),
	    array('update_time','time',self::MODEL_UPDATE,'function'),
	    );

    public function __construct()
    {
	if(isset($_POST['id']))
	{
	    $extra = array(
		array('repassword','password','确认密码不一致',self::EXISTS_VAILIDATE,'confirm'),
	    );
	}
	else
	{
	    $extra = array(
		array('password','require','密码必须'),
		array('repassword','require','确认密码必须'),
		array('repassword','password','确认密码不一致',self::EXISTS_VAILIDATE,'confirm'),
	    );
	}
	$this->_validate = array_merge($this->_validate,$extra);
	parent::__construct();
    }
    protected function pwdHash() {
	    if(isset($_POST['password'])) {
		    return pwdHash($_POST['password']);
	    }else{
		    return false;
	    }
    }
}
?>
